(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = global || self, factory(global.library = {}));
}(this, function (exports) { 'use strict';

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var _global = createCommonjsModule(function (module) {
	var global = module.exports = typeof window != 'undefined' && window.Math == Math
	  ? window : typeof self != 'undefined' && self.Math == Math ? self
	  : Function('return this')();
	if (typeof __g == 'number') __g = global;
	});

	var _core = createCommonjsModule(function (module) {
	var core = module.exports = { version: '2.6.12' };
	if (typeof __e == 'number') __e = core;
	});
	var _core_1 = _core.version;

	var _aFunction = function (it) {
	  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
	  return it;
	};

	var _ctx = function (fn, that, length) {
	  _aFunction(fn);
	  if (that === undefined) return fn;
	  switch (length) {
	    case 1: return function (a) {
	      return fn.call(that, a);
	    };
	    case 2: return function (a, b) {
	      return fn.call(that, a, b);
	    };
	    case 3: return function (a, b, c) {
	      return fn.call(that, a, b, c);
	    };
	  }
	  return function () {
	    return fn.apply(that, arguments);
	  };
	};

	var _isObject = function (it) {
	  return typeof it === 'object' ? it !== null : typeof it === 'function';
	};

	var _anObject = function (it) {
	  if (!_isObject(it)) throw TypeError(it + ' is not an object!');
	  return it;
	};

	var _fails = function (exec) {
	  try {
	    return !!exec();
	  } catch (e) {
	    return true;
	  }
	};

	var _descriptors = !_fails(function () {
	  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
	});

	var document$1 = _global.document;
	var is = _isObject(document$1) && _isObject(document$1.createElement);
	var _domCreate = function (it) {
	  return is ? document$1.createElement(it) : {};
	};

	var _ie8DomDefine = !_descriptors && !_fails(function () {
	  return Object.defineProperty(_domCreate('div'), 'a', { get: function () { return 7; } }).a != 7;
	});

	var _toPrimitive = function (it, S) {
	  if (!_isObject(it)) return it;
	  var fn, val;
	  if (S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
	  if (typeof (fn = it.valueOf) == 'function' && !_isObject(val = fn.call(it))) return val;
	  if (!S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
	  throw TypeError("Can't convert object to primitive value");
	};

	var dP = Object.defineProperty;
	var f = _descriptors ? Object.defineProperty : function defineProperty(O, P, Attributes) {
	  _anObject(O);
	  P = _toPrimitive(P, true);
	  _anObject(Attributes);
	  if (_ie8DomDefine) try {
	    return dP(O, P, Attributes);
	  } catch (e) {  }
	  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
	  if ('value' in Attributes) O[P] = Attributes.value;
	  return O;
	};
	var _objectDp = {
		f: f
	};

	var _propertyDesc = function (bitmap, value) {
	  return {
	    enumerable: !(bitmap & 1),
	    configurable: !(bitmap & 2),
	    writable: !(bitmap & 4),
	    value: value
	  };
	};

	var _hide = _descriptors ? function (object, key, value) {
	  return _objectDp.f(object, key, _propertyDesc(1, value));
	} : function (object, key, value) {
	  object[key] = value;
	  return object;
	};

	var hasOwnProperty = {}.hasOwnProperty;
	var _has = function (it, key) {
	  return hasOwnProperty.call(it, key);
	};

	var PROTOTYPE = 'prototype';
	var $export = function (type, name, source) {
	  var IS_FORCED = type & $export.F;
	  var IS_GLOBAL = type & $export.G;
	  var IS_STATIC = type & $export.S;
	  var IS_PROTO = type & $export.P;
	  var IS_BIND = type & $export.B;
	  var IS_WRAP = type & $export.W;
	  var exports = IS_GLOBAL ? _core : _core[name] || (_core[name] = {});
	  var expProto = exports[PROTOTYPE];
	  var target = IS_GLOBAL ? _global : IS_STATIC ? _global[name] : (_global[name] || {})[PROTOTYPE];
	  var key, own, out;
	  if (IS_GLOBAL) source = name;
	  for (key in source) {
	    own = !IS_FORCED && target && target[key] !== undefined;
	    if (own && _has(exports, key)) continue;
	    out = own ? target[key] : source[key];
	    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
	    : IS_BIND && own ? _ctx(out, _global)
	    : IS_WRAP && target[key] == out ? (function (C) {
	      var F = function (a, b, c) {
	        if (this instanceof C) {
	          switch (arguments.length) {
	            case 0: return new C();
	            case 1: return new C(a);
	            case 2: return new C(a, b);
	          } return new C(a, b, c);
	        } return C.apply(this, arguments);
	      };
	      F[PROTOTYPE] = C[PROTOTYPE];
	      return F;
	    })(out) : IS_PROTO && typeof out == 'function' ? _ctx(Function.call, out) : out;
	    if (IS_PROTO) {
	      (exports.virtual || (exports.virtual = {}))[key] = out;
	      if (type & $export.R && expProto && !expProto[key]) _hide(expProto, key, out);
	    }
	  }
	};
	$export.F = 1;
	$export.G = 2;
	$export.S = 4;
	$export.P = 8;
	$export.B = 16;
	$export.W = 32;
	$export.U = 64;
	$export.R = 128;
	var _export = $export;

	var toString = {}.toString;
	var _cof = function (it) {
	  return toString.call(it).slice(8, -1);
	};

	var _isArray = Array.isArray || function isArray(arg) {
	  return _cof(arg) == 'Array';
	};

	_export(_export.S, 'Array', { isArray: _isArray });

	var isArray = _core.Array.isArray;

	var isArray$1 = isArray;

	function _regeneratorRuntime() {
	  _regeneratorRuntime = function () {
	    return e;
	  };
	  var t,
	    e = {},
	    r = Object.prototype,
	    n = r.hasOwnProperty,
	    o = Object.defineProperty || function (t, e, r) {
	      t[e] = r.value;
	    },
	    i = "function" == typeof Symbol ? Symbol : {},
	    a = i.iterator || "@@iterator",
	    c = i.asyncIterator || "@@asyncIterator",
	    u = i.toStringTag || "@@toStringTag";
	  function define(t, e, r) {
	    return Object.defineProperty(t, e, {
	      value: r,
	      enumerable: !0,
	      configurable: !0,
	      writable: !0
	    }), t[e];
	  }
	  try {
	    define({}, "");
	  } catch (t) {
	    define = function (t, e, r) {
	      return t[e] = r;
	    };
	  }
	  function wrap(t, e, r, n) {
	    var i = e && e.prototype instanceof Generator ? e : Generator,
	      a = Object.create(i.prototype),
	      c = new Context(n || []);
	    return o(a, "_invoke", {
	      value: makeInvokeMethod(t, r, c)
	    }), a;
	  }
	  function tryCatch(t, e, r) {
	    try {
	      return {
	        type: "normal",
	        arg: t.call(e, r)
	      };
	    } catch (t) {
	      return {
	        type: "throw",
	        arg: t
	      };
	    }
	  }
	  e.wrap = wrap;
	  var h = "suspendedStart",
	    l = "suspendedYield",
	    f = "executing",
	    s = "completed",
	    y = {};
	  function Generator() {}
	  function GeneratorFunction() {}
	  function GeneratorFunctionPrototype() {}
	  var p = {};
	  define(p, a, function () {
	    return this;
	  });
	  var d = Object.getPrototypeOf,
	    v = d && d(d(values([])));
	  v && v !== r && n.call(v, a) && (p = v);
	  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
	  function defineIteratorMethods(t) {
	    ["next", "throw", "return"].forEach(function (e) {
	      define(t, e, function (t) {
	        return this._invoke(e, t);
	      });
	    });
	  }
	  function AsyncIterator(t, e) {
	    function invoke(r, o, i, a) {
	      var c = tryCatch(t[r], t, o);
	      if ("throw" !== c.type) {
	        var u = c.arg,
	          h = u.value;
	        return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
	          invoke("next", t, i, a);
	        }, function (t) {
	          invoke("throw", t, i, a);
	        }) : e.resolve(h).then(function (t) {
	          u.value = t, i(u);
	        }, function (t) {
	          return invoke("throw", t, i, a);
	        });
	      }
	      a(c.arg);
	    }
	    var r;
	    o(this, "_invoke", {
	      value: function (t, n) {
	        function callInvokeWithMethodAndArg() {
	          return new e(function (e, r) {
	            invoke(t, n, e, r);
	          });
	        }
	        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
	      }
	    });
	  }
	  function makeInvokeMethod(e, r, n) {
	    var o = h;
	    return function (i, a) {
	      if (o === f) throw new Error("Generator is already running");
	      if (o === s) {
	        if ("throw" === i) throw a;
	        return {
	          value: t,
	          done: !0
	        };
	      }
	      for (n.method = i, n.arg = a;;) {
	        var c = n.delegate;
	        if (c) {
	          var u = maybeInvokeDelegate(c, n);
	          if (u) {
	            if (u === y) continue;
	            return u;
	          }
	        }
	        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
	          if (o === h) throw o = s, n.arg;
	          n.dispatchException(n.arg);
	        } else "return" === n.method && n.abrupt("return", n.arg);
	        o = f;
	        var p = tryCatch(e, r, n);
	        if ("normal" === p.type) {
	          if (o = n.done ? s : l, p.arg === y) continue;
	          return {
	            value: p.arg,
	            done: n.done
	          };
	        }
	        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
	      }
	    };
	  }
	  function maybeInvokeDelegate(e, r) {
	    var n = r.method,
	      o = e.iterator[n];
	    if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
	    var i = tryCatch(o, e.iterator, r.arg);
	    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
	    var a = i.arg;
	    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
	  }
	  function pushTryEntry(t) {
	    var e = {
	      tryLoc: t[0]
	    };
	    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
	  }
	  function resetTryEntry(t) {
	    var e = t.completion || {};
	    e.type = "normal", delete e.arg, t.completion = e;
	  }
	  function Context(t) {
	    this.tryEntries = [{
	      tryLoc: "root"
	    }], t.forEach(pushTryEntry, this), this.reset(!0);
	  }
	  function values(e) {
	    if (e || "" === e) {
	      var r = e[a];
	      if (r) return r.call(e);
	      if ("function" == typeof e.next) return e;
	      if (!isNaN(e.length)) {
	        var o = -1,
	          i = function next() {
	            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
	            return next.value = t, next.done = !0, next;
	          };
	        return i.next = i;
	      }
	    }
	    throw new TypeError(typeof e + " is not iterable");
	  }
	  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
	    value: GeneratorFunctionPrototype,
	    configurable: !0
	  }), o(GeneratorFunctionPrototype, "constructor", {
	    value: GeneratorFunction,
	    configurable: !0
	  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
	    var e = "function" == typeof t && t.constructor;
	    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
	  }, e.mark = function (t) {
	    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
	  }, e.awrap = function (t) {
	    return {
	      __await: t
	    };
	  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
	    return this;
	  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
	    void 0 === i && (i = Promise);
	    var a = new AsyncIterator(wrap(t, r, n, o), i);
	    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
	      return t.done ? t.value : a.next();
	    });
	  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
	    return this;
	  }), define(g, "toString", function () {
	    return "[object Generator]";
	  }), e.keys = function (t) {
	    var e = Object(t),
	      r = [];
	    for (var n in e) r.push(n);
	    return r.reverse(), function next() {
	      for (; r.length;) {
	        var t = r.pop();
	        if (t in e) return next.value = t, next.done = !1, next;
	      }
	      return next.done = !0, next;
	    };
	  }, e.values = values, Context.prototype = {
	    constructor: Context,
	    reset: function (e) {
	      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
	    },
	    stop: function () {
	      this.done = !0;
	      var t = this.tryEntries[0].completion;
	      if ("throw" === t.type) throw t.arg;
	      return this.rval;
	    },
	    dispatchException: function (e) {
	      if (this.done) throw e;
	      var r = this;
	      function handle(n, o) {
	        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
	      }
	      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
	        var i = this.tryEntries[o],
	          a = i.completion;
	        if ("root" === i.tryLoc) return handle("end");
	        if (i.tryLoc <= this.prev) {
	          var c = n.call(i, "catchLoc"),
	            u = n.call(i, "finallyLoc");
	          if (c && u) {
	            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
	            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
	          } else if (c) {
	            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
	          } else {
	            if (!u) throw new Error("try statement without catch or finally");
	            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
	          }
	        }
	      }
	    },
	    abrupt: function (t, e) {
	      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
	        var o = this.tryEntries[r];
	        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
	          var i = o;
	          break;
	        }
	      }
	      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
	      var a = i ? i.completion : {};
	      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
	    },
	    complete: function (t, e) {
	      if ("throw" === t.type) throw t.arg;
	      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
	    },
	    finish: function (t) {
	      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
	        var r = this.tryEntries[e];
	        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
	      }
	    },
	    catch: function (t) {
	      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
	        var r = this.tryEntries[e];
	        if (r.tryLoc === t) {
	          var n = r.completion;
	          if ("throw" === n.type) {
	            var o = n.arg;
	            resetTryEntry(r);
	          }
	          return o;
	        }
	      }
	      throw new Error("illegal catch attempt");
	    },
	    delegateYield: function (e, r, n) {
	      return this.delegate = {
	        iterator: values(e),
	        resultName: r,
	        nextLoc: n
	      }, "next" === this.method && (this.arg = t), y;
	    }
	  }, e;
	}
	function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
	  try {
	    var info = gen[key](arg);
	    var value = info.value;
	  } catch (error) {
	    reject(error);
	    return;
	  }
	  if (info.done) {
	    resolve(value);
	  } else {
	    Promise.resolve(value).then(_next, _throw);
	  }
	}
	function _asyncToGenerator(fn) {
	  return function () {
	    var self = this,
	      args = arguments;
	    return new Promise(function (resolve, reject) {
	      var gen = fn.apply(self, args);
	      function _next(value) {
	        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
	      }
	      function _throw(err) {
	        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
	      }
	      _next(undefined);
	    });
	  };
	}

	var ceil = Math.ceil;
	var floor = Math.floor;
	var _toInteger = function (it) {
	  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
	};

	var _defined = function (it) {
	  if (it == undefined) throw TypeError("Can't call method on  " + it);
	  return it;
	};

	var _stringAt = function (TO_STRING) {
	  return function (that, pos) {
	    var s = String(_defined(that));
	    var i = _toInteger(pos);
	    var l = s.length;
	    var a, b;
	    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
	    a = s.charCodeAt(i);
	    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
	      ? TO_STRING ? s.charAt(i) : a
	      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
	  };
	};

	var _library = true;

	var _redefine = _hide;

	var _iterators = {};

	var _iobject = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
	  return _cof(it) == 'String' ? it.split('') : Object(it);
	};

	var _toIobject = function (it) {
	  return _iobject(_defined(it));
	};

	var min = Math.min;
	var _toLength = function (it) {
	  return it > 0 ? min(_toInteger(it), 0x1fffffffffffff) : 0;
	};

	var max = Math.max;
	var min$1 = Math.min;
	var _toAbsoluteIndex = function (index, length) {
	  index = _toInteger(index);
	  return index < 0 ? max(index + length, 0) : min$1(index, length);
	};

	var _arrayIncludes = function (IS_INCLUDES) {
	  return function ($this, el, fromIndex) {
	    var O = _toIobject($this);
	    var length = _toLength(O.length);
	    var index = _toAbsoluteIndex(fromIndex, length);
	    var value;
	    if (IS_INCLUDES && el != el) while (length > index) {
	      value = O[index++];
	      if (value != value) return true;
	    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
	      if (O[index] === el) return IS_INCLUDES || index || 0;
	    } return !IS_INCLUDES && -1;
	  };
	};

	var _shared = createCommonjsModule(function (module) {
	var SHARED = '__core-js_shared__';
	var store = _global[SHARED] || (_global[SHARED] = {});
	(module.exports = function (key, value) {
	  return store[key] || (store[key] = value !== undefined ? value : {});
	})('versions', []).push({
	  version: _core.version,
	  mode:  'pure' ,
	  copyright: '© 2020 Denis Pushkarev (zloirock.ru)'
	});
	});

	var id = 0;
	var px = Math.random();
	var _uid = function (key) {
	  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
	};

	var shared = _shared('keys');
	var _sharedKey = function (key) {
	  return shared[key] || (shared[key] = _uid(key));
	};

	var arrayIndexOf = _arrayIncludes(false);
	var IE_PROTO = _sharedKey('IE_PROTO');
	var _objectKeysInternal = function (object, names) {
	  var O = _toIobject(object);
	  var i = 0;
	  var result = [];
	  var key;
	  for (key in O) if (key != IE_PROTO) _has(O, key) && result.push(key);
	  while (names.length > i) if (_has(O, key = names[i++])) {
	    ~arrayIndexOf(result, key) || result.push(key);
	  }
	  return result;
	};

	var _enumBugKeys = (
	  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
	).split(',');

	var _objectKeys = Object.keys || function keys(O) {
	  return _objectKeysInternal(O, _enumBugKeys);
	};

	var _objectDps = _descriptors ? Object.defineProperties : function defineProperties(O, Properties) {
	  _anObject(O);
	  var keys = _objectKeys(Properties);
	  var length = keys.length;
	  var i = 0;
	  var P;
	  while (length > i) _objectDp.f(O, P = keys[i++], Properties[P]);
	  return O;
	};

	var document$2 = _global.document;
	var _html = document$2 && document$2.documentElement;

	var IE_PROTO$1 = _sharedKey('IE_PROTO');
	var Empty = function () {  };
	var PROTOTYPE$1 = 'prototype';
	var createDict = function () {
	  var iframe = _domCreate('iframe');
	  var i = _enumBugKeys.length;
	  var lt = '<';
	  var gt = '>';
	  var iframeDocument;
	  iframe.style.display = 'none';
	  _html.appendChild(iframe);
	  iframe.src = 'javascript:';
	  iframeDocument = iframe.contentWindow.document;
	  iframeDocument.open();
	  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
	  iframeDocument.close();
	  createDict = iframeDocument.F;
	  while (i--) delete createDict[PROTOTYPE$1][_enumBugKeys[i]];
	  return createDict();
	};
	var _objectCreate = Object.create || function create(O, Properties) {
	  var result;
	  if (O !== null) {
	    Empty[PROTOTYPE$1] = _anObject(O);
	    result = new Empty();
	    Empty[PROTOTYPE$1] = null;
	    result[IE_PROTO$1] = O;
	  } else result = createDict();
	  return Properties === undefined ? result : _objectDps(result, Properties);
	};

	var _wks = createCommonjsModule(function (module) {
	var store = _shared('wks');
	var Symbol = _global.Symbol;
	var USE_SYMBOL = typeof Symbol == 'function';
	var $exports = module.exports = function (name) {
	  return store[name] || (store[name] =
	    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : _uid)('Symbol.' + name));
	};
	$exports.store = store;
	});

	var def = _objectDp.f;
	var TAG = _wks('toStringTag');
	var _setToStringTag = function (it, tag, stat) {
	  if (it && !_has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
	};

	var IteratorPrototype = {};
	_hide(IteratorPrototype, _wks('iterator'), function () { return this; });
	var _iterCreate = function (Constructor, NAME, next) {
	  Constructor.prototype = _objectCreate(IteratorPrototype, { next: _propertyDesc(1, next) });
	  _setToStringTag(Constructor, NAME + ' Iterator');
	};

	var _toObject = function (it) {
	  return Object(_defined(it));
	};

	var IE_PROTO$2 = _sharedKey('IE_PROTO');
	var ObjectProto = Object.prototype;
	var _objectGpo = Object.getPrototypeOf || function (O) {
	  O = _toObject(O);
	  if (_has(O, IE_PROTO$2)) return O[IE_PROTO$2];
	  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
	    return O.constructor.prototype;
	  } return O instanceof Object ? ObjectProto : null;
	};

	var ITERATOR = _wks('iterator');
	var BUGGY = !([].keys && 'next' in [].keys());
	var FF_ITERATOR = '@@iterator';
	var KEYS = 'keys';
	var VALUES = 'values';
	var returnThis = function () { return this; };
	var _iterDefine = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
	  _iterCreate(Constructor, NAME, next);
	  var getMethod = function (kind) {
	    if (!BUGGY && kind in proto) return proto[kind];
	    switch (kind) {
	      case KEYS: return function keys() { return new Constructor(this, kind); };
	      case VALUES: return function values() { return new Constructor(this, kind); };
	    } return function entries() { return new Constructor(this, kind); };
	  };
	  var TAG = NAME + ' Iterator';
	  var DEF_VALUES = DEFAULT == VALUES;
	  var VALUES_BUG = false;
	  var proto = Base.prototype;
	  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
	  var $default = $native || getMethod(DEFAULT);
	  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
	  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
	  var methods, key, IteratorPrototype;
	  if ($anyNative) {
	    IteratorPrototype = _objectGpo($anyNative.call(new Base()));
	    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
	      _setToStringTag(IteratorPrototype, TAG, true);
	    }
	  }
	  if (DEF_VALUES && $native && $native.name !== VALUES) {
	    VALUES_BUG = true;
	    $default = function values() { return $native.call(this); };
	  }
	  if (( FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
	    _hide(proto, ITERATOR, $default);
	  }
	  _iterators[NAME] = $default;
	  _iterators[TAG] = returnThis;
	  if (DEFAULT) {
	    methods = {
	      values: DEF_VALUES ? $default : getMethod(VALUES),
	      keys: IS_SET ? $default : getMethod(KEYS),
	      entries: $entries
	    };
	    if (FORCED) for (key in methods) {
	      if (!(key in proto)) _redefine(proto, key, methods[key]);
	    } else _export(_export.P + _export.F * (BUGGY || VALUES_BUG), NAME, methods);
	  }
	  return methods;
	};

	var $at = _stringAt(true);
	_iterDefine(String, 'String', function (iterated) {
	  this._t = String(iterated);
	  this._i = 0;
	}, function () {
	  var O = this._t;
	  var index = this._i;
	  var point;
	  if (index >= O.length) return { value: undefined, done: true };
	  point = $at(O, index);
	  this._i += point.length;
	  return { value: point, done: false };
	});

	var _iterStep = function (done, value) {
	  return { value: value, done: !!done };
	};

	var es6_array_iterator = _iterDefine(Array, 'Array', function (iterated, kind) {
	  this._t = _toIobject(iterated);
	  this._i = 0;
	  this._k = kind;
	}, function () {
	  var O = this._t;
	  var kind = this._k;
	  var index = this._i++;
	  if (!O || index >= O.length) {
	    this._t = undefined;
	    return _iterStep(1);
	  }
	  if (kind == 'keys') return _iterStep(0, index);
	  if (kind == 'values') return _iterStep(0, O[index]);
	  return _iterStep(0, [index, O[index]]);
	}, 'values');
	_iterators.Arguments = _iterators.Array;

	var TO_STRING_TAG = _wks('toStringTag');
	var DOMIterables = ('CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,' +
	  'DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,' +
	  'MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,' +
	  'SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,' +
	  'TextTrackList,TouchList').split(',');
	for (var i = 0; i < DOMIterables.length; i++) {
	  var NAME = DOMIterables[i];
	  var Collection = _global[NAME];
	  var proto = Collection && Collection.prototype;
	  if (proto && !proto[TO_STRING_TAG]) _hide(proto, TO_STRING_TAG, NAME);
	  _iterators[NAME] = _iterators.Array;
	}

	var TAG$1 = _wks('toStringTag');
	var ARG = _cof(function () { return arguments; }()) == 'Arguments';
	var tryGet = function (it, key) {
	  try {
	    return it[key];
	  } catch (e) {  }
	};
	var _classof = function (it) {
	  var O, T, B;
	  return it === undefined ? 'Undefined' : it === null ? 'Null'
	    : typeof (T = tryGet(O = Object(it), TAG$1)) == 'string' ? T
	    : ARG ? _cof(O)
	    : (B = _cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
	};

	var _anInstance = function (it, Constructor, name, forbiddenField) {
	  if (!(it instanceof Constructor) || (forbiddenField !== undefined && forbiddenField in it)) {
	    throw TypeError(name + ': incorrect invocation!');
	  } return it;
	};

	var _iterCall = function (iterator, fn, value, entries) {
	  try {
	    return entries ? fn(_anObject(value)[0], value[1]) : fn(value);
	  } catch (e) {
	    var ret = iterator['return'];
	    if (ret !== undefined) _anObject(ret.call(iterator));
	    throw e;
	  }
	};

	var ITERATOR$1 = _wks('iterator');
	var ArrayProto = Array.prototype;
	var _isArrayIter = function (it) {
	  return it !== undefined && (_iterators.Array === it || ArrayProto[ITERATOR$1] === it);
	};

	var ITERATOR$2 = _wks('iterator');
	var core_getIteratorMethod = _core.getIteratorMethod = function (it) {
	  if (it != undefined) return it[ITERATOR$2]
	    || it['@@iterator']
	    || _iterators[_classof(it)];
	};

	var _forOf = createCommonjsModule(function (module) {
	var BREAK = {};
	var RETURN = {};
	var exports = module.exports = function (iterable, entries, fn, that, ITERATOR) {
	  var iterFn = ITERATOR ? function () { return iterable; } : core_getIteratorMethod(iterable);
	  var f = _ctx(fn, that, entries ? 2 : 1);
	  var index = 0;
	  var length, step, iterator, result;
	  if (typeof iterFn != 'function') throw TypeError(iterable + ' is not iterable!');
	  if (_isArrayIter(iterFn)) for (length = _toLength(iterable.length); length > index; index++) {
	    result = entries ? f(_anObject(step = iterable[index])[0], step[1]) : f(iterable[index]);
	    if (result === BREAK || result === RETURN) return result;
	  } else for (iterator = iterFn.call(iterable); !(step = iterator.next()).done;) {
	    result = _iterCall(iterator, f, step.value, entries);
	    if (result === BREAK || result === RETURN) return result;
	  }
	};
	exports.BREAK = BREAK;
	exports.RETURN = RETURN;
	});

	var SPECIES = _wks('species');
	var _speciesConstructor = function (O, D) {
	  var C = _anObject(O).constructor;
	  var S;
	  return C === undefined || (S = _anObject(C)[SPECIES]) == undefined ? D : _aFunction(S);
	};

	var _invoke = function (fn, args, that) {
	  var un = that === undefined;
	  switch (args.length) {
	    case 0: return un ? fn()
	                      : fn.call(that);
	    case 1: return un ? fn(args[0])
	                      : fn.call(that, args[0]);
	    case 2: return un ? fn(args[0], args[1])
	                      : fn.call(that, args[0], args[1]);
	    case 3: return un ? fn(args[0], args[1], args[2])
	                      : fn.call(that, args[0], args[1], args[2]);
	    case 4: return un ? fn(args[0], args[1], args[2], args[3])
	                      : fn.call(that, args[0], args[1], args[2], args[3]);
	  } return fn.apply(that, args);
	};

	var process = _global.process;
	var setTask = _global.setImmediate;
	var clearTask = _global.clearImmediate;
	var MessageChannel = _global.MessageChannel;
	var Dispatch = _global.Dispatch;
	var counter = 0;
	var queue = {};
	var ONREADYSTATECHANGE = 'onreadystatechange';
	var defer, channel, port;
	var run = function () {
	  var id = +this;
	  if (queue.hasOwnProperty(id)) {
	    var fn = queue[id];
	    delete queue[id];
	    fn();
	  }
	};
	var listener = function (event) {
	  run.call(event.data);
	};
	if (!setTask || !clearTask) {
	  setTask = function setImmediate(fn) {
	    var args = [];
	    var i = 1;
	    while (arguments.length > i) args.push(arguments[i++]);
	    queue[++counter] = function () {
	      _invoke(typeof fn == 'function' ? fn : Function(fn), args);
	    };
	    defer(counter);
	    return counter;
	  };
	  clearTask = function clearImmediate(id) {
	    delete queue[id];
	  };
	  if (_cof(process) == 'process') {
	    defer = function (id) {
	      process.nextTick(_ctx(run, id, 1));
	    };
	  } else if (Dispatch && Dispatch.now) {
	    defer = function (id) {
	      Dispatch.now(_ctx(run, id, 1));
	    };
	  } else if (MessageChannel) {
	    channel = new MessageChannel();
	    port = channel.port2;
	    channel.port1.onmessage = listener;
	    defer = _ctx(port.postMessage, port, 1);
	  } else if (_global.addEventListener && typeof postMessage == 'function' && !_global.importScripts) {
	    defer = function (id) {
	      _global.postMessage(id + '', '*');
	    };
	    _global.addEventListener('message', listener, false);
	  } else if (ONREADYSTATECHANGE in _domCreate('script')) {
	    defer = function (id) {
	      _html.appendChild(_domCreate('script'))[ONREADYSTATECHANGE] = function () {
	        _html.removeChild(this);
	        run.call(id);
	      };
	    };
	  } else {
	    defer = function (id) {
	      setTimeout(_ctx(run, id, 1), 0);
	    };
	  }
	}
	var _task = {
	  set: setTask,
	  clear: clearTask
	};

	var macrotask = _task.set;
	var Observer = _global.MutationObserver || _global.WebKitMutationObserver;
	var process$1 = _global.process;
	var Promise$1 = _global.Promise;
	var isNode = _cof(process$1) == 'process';
	var _microtask = function () {
	  var head, last, notify;
	  var flush = function () {
	    var parent, fn;
	    if (isNode && (parent = process$1.domain)) parent.exit();
	    while (head) {
	      fn = head.fn;
	      head = head.next;
	      try {
	        fn();
	      } catch (e) {
	        if (head) notify();
	        else last = undefined;
	        throw e;
	      }
	    } last = undefined;
	    if (parent) parent.enter();
	  };
	  if (isNode) {
	    notify = function () {
	      process$1.nextTick(flush);
	    };
	  } else if (Observer && !(_global.navigator && _global.navigator.standalone)) {
	    var toggle = true;
	    var node = document.createTextNode('');
	    new Observer(flush).observe(node, { characterData: true });
	    notify = function () {
	      node.data = toggle = !toggle;
	    };
	  } else if (Promise$1 && Promise$1.resolve) {
	    var promise = Promise$1.resolve(undefined);
	    notify = function () {
	      promise.then(flush);
	    };
	  } else {
	    notify = function () {
	      macrotask.call(_global, flush);
	    };
	  }
	  return function (fn) {
	    var task = { fn: fn, next: undefined };
	    if (last) last.next = task;
	    if (!head) {
	      head = task;
	      notify();
	    } last = task;
	  };
	};

	function PromiseCapability(C) {
	  var resolve, reject;
	  this.promise = new C(function ($$resolve, $$reject) {
	    if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
	    resolve = $$resolve;
	    reject = $$reject;
	  });
	  this.resolve = _aFunction(resolve);
	  this.reject = _aFunction(reject);
	}
	var f$1 = function (C) {
	  return new PromiseCapability(C);
	};
	var _newPromiseCapability = {
		f: f$1
	};

	var _perform = function (exec) {
	  try {
	    return { e: false, v: exec() };
	  } catch (e) {
	    return { e: true, v: e };
	  }
	};

	var navigator = _global.navigator;
	var _userAgent = navigator && navigator.userAgent || '';

	var _promiseResolve = function (C, x) {
	  _anObject(C);
	  if (_isObject(x) && x.constructor === C) return x;
	  var promiseCapability = _newPromiseCapability.f(C);
	  var resolve = promiseCapability.resolve;
	  resolve(x);
	  return promiseCapability.promise;
	};

	var _redefineAll = function (target, src, safe) {
	  for (var key in src) {
	    if (safe && target[key]) target[key] = src[key];
	    else _hide(target, key, src[key]);
	  } return target;
	};

	var SPECIES$1 = _wks('species');
	var _setSpecies = function (KEY) {
	  var C = typeof _core[KEY] == 'function' ? _core[KEY] : _global[KEY];
	  if (_descriptors && C && !C[SPECIES$1]) _objectDp.f(C, SPECIES$1, {
	    configurable: true,
	    get: function () { return this; }
	  });
	};

	var ITERATOR$3 = _wks('iterator');
	var SAFE_CLOSING = false;
	try {
	  var riter = [7][ITERATOR$3]();
	  riter['return'] = function () { SAFE_CLOSING = true; };
	  Array.from(riter, function () { throw 2; });
	} catch (e) {  }
	var _iterDetect = function (exec, skipClosing) {
	  if (!skipClosing && !SAFE_CLOSING) return false;
	  var safe = false;
	  try {
	    var arr = [7];
	    var iter = arr[ITERATOR$3]();
	    iter.next = function () { return { done: safe = true }; };
	    arr[ITERATOR$3] = function () { return iter; };
	    exec(arr);
	  } catch (e) {  }
	  return safe;
	};

	var task = _task.set;
	var microtask = _microtask();
	var PROMISE = 'Promise';
	var TypeError$1 = _global.TypeError;
	var process$2 = _global.process;
	var versions = process$2 && process$2.versions;
	var v8 = versions && versions.v8 || '';
	var $Promise = _global[PROMISE];
	var isNode$1 = _classof(process$2) == 'process';
	var empty = function () {  };
	var Internal, newGenericPromiseCapability, OwnPromiseCapability, Wrapper;
	var newPromiseCapability = newGenericPromiseCapability = _newPromiseCapability.f;
	var USE_NATIVE = !!function () {
	  try {
	    var promise = $Promise.resolve(1);
	    var FakePromise = (promise.constructor = {})[_wks('species')] = function (exec) {
	      exec(empty, empty);
	    };
	    return (isNode$1 || typeof PromiseRejectionEvent == 'function')
	      && promise.then(empty) instanceof FakePromise
	      && v8.indexOf('6.6') !== 0
	      && _userAgent.indexOf('Chrome/66') === -1;
	  } catch (e) {  }
	}();
	var isThenable = function (it) {
	  var then;
	  return _isObject(it) && typeof (then = it.then) == 'function' ? then : false;
	};
	var notify = function (promise, isReject) {
	  if (promise._n) return;
	  promise._n = true;
	  var chain = promise._c;
	  microtask(function () {
	    var value = promise._v;
	    var ok = promise._s == 1;
	    var i = 0;
	    var run = function (reaction) {
	      var handler = ok ? reaction.ok : reaction.fail;
	      var resolve = reaction.resolve;
	      var reject = reaction.reject;
	      var domain = reaction.domain;
	      var result, then, exited;
	      try {
	        if (handler) {
	          if (!ok) {
	            if (promise._h == 2) onHandleUnhandled(promise);
	            promise._h = 1;
	          }
	          if (handler === true) result = value;
	          else {
	            if (domain) domain.enter();
	            result = handler(value);
	            if (domain) {
	              domain.exit();
	              exited = true;
	            }
	          }
	          if (result === reaction.promise) {
	            reject(TypeError$1('Promise-chain cycle'));
	          } else if (then = isThenable(result)) {
	            then.call(result, resolve, reject);
	          } else resolve(result);
	        } else reject(value);
	      } catch (e) {
	        if (domain && !exited) domain.exit();
	        reject(e);
	      }
	    };
	    while (chain.length > i) run(chain[i++]);
	    promise._c = [];
	    promise._n = false;
	    if (isReject && !promise._h) onUnhandled(promise);
	  });
	};
	var onUnhandled = function (promise) {
	  task.call(_global, function () {
	    var value = promise._v;
	    var unhandled = isUnhandled(promise);
	    var result, handler, console;
	    if (unhandled) {
	      result = _perform(function () {
	        if (isNode$1) {
	          process$2.emit('unhandledRejection', value, promise);
	        } else if (handler = _global.onunhandledrejection) {
	          handler({ promise: promise, reason: value });
	        } else if ((console = _global.console) && console.error) {
	          console.error('Unhandled promise rejection', value);
	        }
	      });
	      promise._h = isNode$1 || isUnhandled(promise) ? 2 : 1;
	    } promise._a = undefined;
	    if (unhandled && result.e) throw result.v;
	  });
	};
	var isUnhandled = function (promise) {
	  return promise._h !== 1 && (promise._a || promise._c).length === 0;
	};
	var onHandleUnhandled = function (promise) {
	  task.call(_global, function () {
	    var handler;
	    if (isNode$1) {
	      process$2.emit('rejectionHandled', promise);
	    } else if (handler = _global.onrejectionhandled) {
	      handler({ promise: promise, reason: promise._v });
	    }
	  });
	};
	var $reject = function (value) {
	  var promise = this;
	  if (promise._d) return;
	  promise._d = true;
	  promise = promise._w || promise;
	  promise._v = value;
	  promise._s = 2;
	  if (!promise._a) promise._a = promise._c.slice();
	  notify(promise, true);
	};
	var $resolve = function (value) {
	  var promise = this;
	  var then;
	  if (promise._d) return;
	  promise._d = true;
	  promise = promise._w || promise;
	  try {
	    if (promise === value) throw TypeError$1("Promise can't be resolved itself");
	    if (then = isThenable(value)) {
	      microtask(function () {
	        var wrapper = { _w: promise, _d: false };
	        try {
	          then.call(value, _ctx($resolve, wrapper, 1), _ctx($reject, wrapper, 1));
	        } catch (e) {
	          $reject.call(wrapper, e);
	        }
	      });
	    } else {
	      promise._v = value;
	      promise._s = 1;
	      notify(promise, false);
	    }
	  } catch (e) {
	    $reject.call({ _w: promise, _d: false }, e);
	  }
	};
	if (!USE_NATIVE) {
	  $Promise = function Promise(executor) {
	    _anInstance(this, $Promise, PROMISE, '_h');
	    _aFunction(executor);
	    Internal.call(this);
	    try {
	      executor(_ctx($resolve, this, 1), _ctx($reject, this, 1));
	    } catch (err) {
	      $reject.call(this, err);
	    }
	  };
	  Internal = function Promise(executor) {
	    this._c = [];
	    this._a = undefined;
	    this._s = 0;
	    this._d = false;
	    this._v = undefined;
	    this._h = 0;
	    this._n = false;
	  };
	  Internal.prototype = _redefineAll($Promise.prototype, {
	    then: function then(onFulfilled, onRejected) {
	      var reaction = newPromiseCapability(_speciesConstructor(this, $Promise));
	      reaction.ok = typeof onFulfilled == 'function' ? onFulfilled : true;
	      reaction.fail = typeof onRejected == 'function' && onRejected;
	      reaction.domain = isNode$1 ? process$2.domain : undefined;
	      this._c.push(reaction);
	      if (this._a) this._a.push(reaction);
	      if (this._s) notify(this, false);
	      return reaction.promise;
	    },
	    'catch': function (onRejected) {
	      return this.then(undefined, onRejected);
	    }
	  });
	  OwnPromiseCapability = function () {
	    var promise = new Internal();
	    this.promise = promise;
	    this.resolve = _ctx($resolve, promise, 1);
	    this.reject = _ctx($reject, promise, 1);
	  };
	  _newPromiseCapability.f = newPromiseCapability = function (C) {
	    return C === $Promise || C === Wrapper
	      ? new OwnPromiseCapability(C)
	      : newGenericPromiseCapability(C);
	  };
	}
	_export(_export.G + _export.W + _export.F * !USE_NATIVE, { Promise: $Promise });
	_setToStringTag($Promise, PROMISE);
	_setSpecies(PROMISE);
	Wrapper = _core[PROMISE];
	_export(_export.S + _export.F * !USE_NATIVE, PROMISE, {
	  reject: function reject(r) {
	    var capability = newPromiseCapability(this);
	    var $$reject = capability.reject;
	    $$reject(r);
	    return capability.promise;
	  }
	});
	_export(_export.S + _export.F * (_library ), PROMISE, {
	  resolve: function resolve(x) {
	    return _promiseResolve( this === Wrapper ? $Promise : this, x);
	  }
	});
	_export(_export.S + _export.F * !(USE_NATIVE && _iterDetect(function (iter) {
	  $Promise.all(iter)['catch'](empty);
	})), PROMISE, {
	  all: function all(iterable) {
	    var C = this;
	    var capability = newPromiseCapability(C);
	    var resolve = capability.resolve;
	    var reject = capability.reject;
	    var result = _perform(function () {
	      var values = [];
	      var index = 0;
	      var remaining = 1;
	      _forOf(iterable, false, function (promise) {
	        var $index = index++;
	        var alreadyCalled = false;
	        values.push(undefined);
	        remaining++;
	        C.resolve(promise).then(function (value) {
	          if (alreadyCalled) return;
	          alreadyCalled = true;
	          values[$index] = value;
	          --remaining || resolve(values);
	        }, reject);
	      });
	      --remaining || resolve(values);
	    });
	    if (result.e) reject(result.v);
	    return capability.promise;
	  },
	  race: function race(iterable) {
	    var C = this;
	    var capability = newPromiseCapability(C);
	    var reject = capability.reject;
	    var result = _perform(function () {
	      _forOf(iterable, false, function (promise) {
	        C.resolve(promise).then(capability.resolve, reject);
	      });
	    });
	    if (result.e) reject(result.v);
	    return capability.promise;
	  }
	});

	_export(_export.P + _export.R, 'Promise', { 'finally': function (onFinally) {
	  var C = _speciesConstructor(this, _core.Promise || _global.Promise);
	  var isFunction = typeof onFinally == 'function';
	  return this.then(
	    isFunction ? function (x) {
	      return _promiseResolve(C, onFinally()).then(function () { return x; });
	    } : onFinally,
	    isFunction ? function (e) {
	      return _promiseResolve(C, onFinally()).then(function () { throw e; });
	    } : onFinally
	  );
	} });

	_export(_export.S, 'Promise', { 'try': function (callbackfn) {
	  var promiseCapability = _newPromiseCapability.f(this);
	  var result = _perform(callbackfn);
	  (result.e ? promiseCapability.reject : promiseCapability.resolve)(result.v);
	  return promiseCapability.promise;
	} });

	var promise = _core.Promise;

	var promise$1 = promise;

	function throttle (delay, noTrailing, callback, debounceMode) {
	  var timeoutID;
	  var cancelled = false;
	  var lastExec = 0;
	  function clearExistingTimeout() {
	    if (timeoutID) {
	      clearTimeout(timeoutID);
	    }
	  }
	  function cancel() {
	    clearExistingTimeout();
	    cancelled = true;
	  }
	  if (typeof noTrailing !== 'boolean') {
	    debounceMode = callback;
	    callback = noTrailing;
	    noTrailing = undefined;
	  }
	  function wrapper() {
	    var self = this;
	    var elapsed = Date.now() - lastExec;
	    var args = arguments;
	    if (cancelled) {
	      return;
	    }
	    function exec() {
	      lastExec = Date.now();
	      callback.apply(self, args);
	    }
	    function clear() {
	      timeoutID = undefined;
	    }
	    if (debounceMode && !timeoutID) {
	      exec();
	    }
	    clearExistingTimeout();
	    if (debounceMode === undefined && elapsed > delay) {
	      exec();
	    } else if (noTrailing !== true) {
	      timeoutID = setTimeout(debounceMode ? clear : exec, debounceMode === undefined ? delay - elapsed : delay);
	    }
	  }
	  wrapper.cancel = cancel;
	  return wrapper;
	}
	function debounce (delay, atBegin, callback) {
	  return callback === undefined ? throttle(delay, atBegin, false) : throttle(delay, callback, atBegin !== false);
	}

	var requestFrame = function () {
	  var raf = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || function (fn) {
	    return window.setTimeout(fn, 20);
	  };
	  return function (fn) {
	    return raf(fn);
	  };
	}();
	var cancelFrame = function () {
	  var cancel = window.cancelAnimationFrame || window.mozCancelAnimationFrame || window.webkitCancelAnimationFrame || window.clearTimeout;
	  return function (id) {
	    return cancel(id);
	  };
	}();
	var resetTrigger = function resetTrigger(element) {
	  var trigger = element.__resizeTrigger__;
	  var expand = trigger.firstElementChild;
	  var contract = trigger.lastElementChild;
	  var expandChild = expand.firstElementChild;
	  contract.scrollLeft = contract.scrollWidth;
	  contract.scrollTop = contract.scrollHeight;
	  expandChild.style.width = expand.offsetWidth + 1 + 'px';
	  expandChild.style.height = expand.offsetHeight + 1 + 'px';
	  expand.scrollLeft = expand.scrollWidth;
	  expand.scrollTop = expand.scrollHeight;
	};
	var checkTriggers = function checkTriggers(element) {
	  return element.offsetWidth !== element.__resizeLast__.width || element.offsetHeight !== element.__resizeLast__.height;
	};
	var scrollListener = function scrollListener(event) {
	  var _this = this;
	  resetTrigger(this);
	  if (this.__resizeRAF__) cancelFrame(this.__resizeRAF__);
	  this.__resizeRAF__ = requestFrame(function () {
	    if (checkTriggers(_this)) {
	      _this.__resizeLast__.width = _this.offsetWidth;
	      _this.__resizeLast__.height = _this.offsetHeight;
	      _this.__resizeListeners__.forEach(function (fn) {
	        fn.call(_this, event);
	      });
	    }
	  });
	};
	var attachEvent = document.attachEvent;
	var DOM_PREFIXES = 'Webkit Moz O ms'.split(' ');
	var START_EVENTS = 'webkitAnimationStart animationstart oAnimationStart MSAnimationStart'.split(' ');
	var RESIZE_ANIMATION_NAME = 'resizeanim';
	var animation = false;
	var keyFramePrefix = '';
	var animationStartEvent = 'animationstart';
	if (!attachEvent) {
	  var testElement = document.createElement('fakeelement');
	  if (testElement.style.animationName !== undefined) {
	    animation = true;
	  }
	  if (animation === false) {
	    var prefix = '';
	    for (var i$1 = 0; i$1 < DOM_PREFIXES.length; i$1++) {
	      if (testElement.style[DOM_PREFIXES[i$1] + 'AnimationName'] !== undefined) {
	        prefix = DOM_PREFIXES[i$1];
	        keyFramePrefix = '-' + prefix.toLowerCase() + '-';
	        animationStartEvent = START_EVENTS[i$1];
	        animation = true;
	        break;
	      }
	    }
	  }
	}
	var stylesCreated = false;
	var createStyles = function createStyles() {
	  if (!stylesCreated) {
	    var animationKeyframes = "@".concat(keyFramePrefix, "keyframes ").concat(RESIZE_ANIMATION_NAME, " { from { opacity: 0; } to { opacity: 0; } } ");
	    var animationStyle = "".concat(keyFramePrefix, "animation: 1ms ").concat(RESIZE_ANIMATION_NAME, ";");
	    var css = "".concat(animationKeyframes, "\n      .resize-triggers { ").concat(animationStyle, " visibility: hidden; opacity: 0; }\n      .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: \" \"; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1 }\n      .resize-triggers > div { background: #eee; overflow: auto; }\n      .contract-trigger:before { width: 200%; height: 200%; }");
	    var head = document.head || document.getElementsByTagName('head')[0];
	    var style = document.createElement('style');
	    style.type = 'text/css';
	    if (style.styleSheet) {
	      style.styleSheet.cssText = css;
	    } else {
	      style.appendChild(document.createTextNode(css));
	    }
	    head.appendChild(style);
	    stylesCreated = true;
	  }
	};
	var addResizeListener = function addResizeListener(element, fn) {
	  var useCapture = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
	  console.log('000000 => ', '我是输出');
	  if (attachEvent) {
	    element.attachEvent('onresize', fn);
	  } else {
	    if (!element.__resizeTrigger__) {
	      if (getComputedStyle(element).position === 'static') {
	        element.style.position = 'relative';
	      }
	      createStyles();
	      element.__resizeLast__ = {};
	      element.__resizeListeners__ = [];
	      var resizeTrigger = element.__resizeTrigger__ = document.createElement('div');
	      resizeTrigger.className = 'resize-triggers';
	      resizeTrigger.innerHTML = '<div class="expand-trigger"><div></div></div><div class="contract-trigger"></div>';
	      element.appendChild(resizeTrigger);
	      resetTrigger(element);
	      element.addEventListener('scroll', scrollListener, useCapture);
	      if (animationStartEvent) {
	        resizeTrigger.addEventListener(animationStartEvent, function (event) {
	          if (event.animationName === RESIZE_ANIMATION_NAME) {
	            resetTrigger(element);
	          }
	        });
	      }
	    }
	    element.__resizeListeners__.push(fn);
	  }
	};
	var removeResizeListener = function removeResizeListener(element, fn) {
	  if (!element || !element.__resizeListeners__) return;
	  if (attachEvent) {
	    element.detachEvent('onresize', fn);
	  } else {
	    element.__resizeListeners__.splice(element.__resizeListeners__.indexOf(fn), 1);
	    if (!element.__resizeListeners__.length) {
	      element.removeEventListener('scroll', scrollListener);
	      element.__resizeTrigger__ = !element.removeChild(element.__resizeTrigger__);
	    }
	  }
	};

	var bkTabLabel = {
	  name: 'bk-tab-label',
	  props: ['panel', 'index', 'closable', 'isSidePosition'],
	  render: function render(h) {
	    var _this = this;
	    var _this$panel = this.panel,
	      renderLabel = _this$panel.renderLabel,
	      $slots = _this$panel.$slots,
	      label = _this$panel.label,
	      name = _this$panel.name;
	    var labelContent = renderLabel && renderLabel(h, name) || $slots.label || label;
	    return h("li", {
	      "on": {
	        "click": function click() {
	          return _this.$parent.togglePanel(_this.panel);
	        }
	      },
	      "class": this.showClose && !this.isSidePosition ? 'has-close' : ''
	    }, [h("div", {
	      "class": "bk-tab-label"
	    }, [labelContent]), this.showClose ? h("i", {
	      "class": "bk-tab-close-controller",
	      "on": {
	        "click": function click($event) {
	          return _this.handleClosePanel($event);
	        }
	      }
	    }) : '']);
	  },
	  computed: {
	    showClose: function showClose() {
	      if (this.panel.disabled) {
	        return false;
	      }
	      if (this.panel.closable !== undefined) {
	        return this.panel.closable;
	      }
	      return this.closable;
	    }
	  },
	  methods: {
	    handleClosePanel: function handleClosePanel(event) {
	      event.stopPropagation();
	      this.$parent.handleClosePanel(this.index, this.panel);
	    }
	  }
	};

	var script = {
	  name: 'bk-tab',
	  components: {
	    bkTabLabel: bkTabLabel
	  },
	  props: {
	    active: {
	      type: [String, Number],
	      default: ''
	    },
	    sortable: {
	      type: Boolean,
	      default: false
	    },
	    sortType: {
	      type: String,
	      default: 'replace'
	    },
	    type: {
	      type: String,
	      default: 'border-card',
	      validator: function validator(val) {
	        return ['card', 'border-card', 'unborder-card', 'vertical-card', 'card-tab'].includes(val);
	      }
	    },
	    tabPosition: {
	      type: String,
	      default: 'top',
	      validator: function validator(val) {
	        return ['left', 'right', 'top'].includes(val);
	      }
	    },
	    scrollStep: {
	      type: Number,
	      default: 200
	    },
	    validateActive: {
	      type: Boolean,
	      default: true
	    },
	    closable: Boolean,
	    addable: Boolean,
	    beforeToggle: Function,
	    extCls: {
	      type: String,
	      default: ''
	    },
	    showHeader: {
	      type: Boolean,
	      default: true
	    },
	    changeOnHover: Boolean,
	    changeOnHoverDelay: {
	      type: Number,
	      default: 1000
	    },
	    labelHeight: {
	      type: Number,
	      default: 50,
	      validator: function validator(val) {
	        if (val < 42) {
	          console.error('选项卡 label 的高度，最小值为 42');
	          return false;
	        }
	        return true;
	      }
	    },
	    activeBar: {
	      type: Object,
	      default: function _default() {
	        return {
	          position: 'bottom',
	          height: '2px'
	        };
	      }
	    },
	    addShowNextRight: {
	      type: Boolean,
	      default: false
	    },
	    size: {
	      type: String,
	      default: '',
	      validator: function validator(val) {
	        return ['', 'small'].includes(val);
	      }
	    }
	  },
	  data: function data() {
	    return {
	      isTab: true,
	      localActive: this.active,
	      scrollState: {
	        show: false,
	        position: 'left',
	        offset: 0,
	        basicStep: this.scrollStep,
	        wrapperRect: null,
	        listRect: null
	      },
	      panelInstance: [],
	      dragenterIndex: -1,
	      dragStartIndex: -1,
	      draggingEle: null,
	      guid: Math.random().toString(16).substr(4) + Math.random().toString(16).substr(4),
	      resizeHandler: null,
	      promise: {
	        toggle: {
	          previousPanel: null,
	          rejector: null
	        }
	      },
	      hoverTimer: null,
	      activeBarStyle: {
	        left: 0,
	        width: 0,
	        height: 0,
	        transform: '',
	        top: '',
	        bottom: ''
	      },
	      addCustomRect: {
	        width: 0
	      },
	      tabSize: this.size
	    };
	  },
	  computed: {
	    panelNames: function panelNames() {
	      return this.panelInstance.map(function (panel) {
	        return panel.name;
	      });
	    },
	    activePanel: function activePanel() {
	      var _this = this;
	      return this.panelInstance.find(function (panel) {
	        return panel.name === _this.localActive;
	      });
	    },
	    visiblePanels: function visiblePanels() {
	      return this.panelInstance.filter(function (panel) {
	        return panel.visible;
	      });
	    },
	    tabClass: function tabClass() {
	      var arr = ['bk-tab', this.extCls];
	      if (this.tabPosition === 'top') {
	        arr.push("bk-tab-".concat(this.type));
	      } else {
	        arr.push("position-".concat(this.tabPosition));
	        if (this.type === 'card-tab') {
	          arr.push("bk-tab-vertical-tab");
	        }
	      }
	      return arr;
	    },
	    tabStyle: function tabStyle() {
	      if (this.isSidePosition) {
	        var paddingValue = 21;
	        return {
	          minHeight: "".concat(this.labelHeight * 4 + paddingValue, "px")
	        };
	      }
	      return {};
	    },
	    headerStyle: function headerStyle() {
	      if (this.tabPosition === 'top') {
	        if (this.type === 'card-tab') {
	          return {
	            height: "".concat(this.labelHeight, "px")
	          };
	        }
	        var diffValue = this.type === 'border-card' ? 2 : 1;
	        return {
	          height: "".concat(this.labelHeight, "px"),
	          backgroundImage: "linear-gradient(transparent ".concat(this.labelHeight - diffValue, "px, #dcdee5 1px)")
	        };
	      }
	      return {};
	    },
	    isSidePosition: function isSidePosition() {
	      return ['left', 'right'].includes(this.tabPosition);
	    },
	    isEmpty: function isEmpty() {
	      return this.panelInstance.length < 1;
	    },
	    hasActiveBar: function hasActiveBar() {
	      if (this.type === 'card-tab') {
	        return false;
	      }
	      return (this.type === 'unborder-card' || this.isSidePosition) && !this.isEmpty;
	    },
	    tabLabelListStyle: function tabLabelListStyle() {
	      if (this.isEmpty) {
	        return {};
	      }
	      if (this.hasActiveBar) {
	        return {
	          transform: "translateX(".concat(this.scrollState.offset, "px)"),
	          height: "".concat(this.labelHeight, "px"),
	          '--activeBarTop': this.activeBarStyle.top,
	          '--activeBarBottom': this.activeBarStyle.bottom,
	          '--activeBarLeft': this.activeBarStyle.left,
	          '--activeBarWidth': this.activeBarStyle.width,
	          '--activeBarHeight': this.activeBarStyle.height,
	          '--activeBarTransform': this.activeBarStyle.transform
	        };
	      }
	      return {
	        transform: "translateX(".concat(this.scrollState.offset, "px)"),
	        height: "".concat(this.labelHeight, "px")
	      };
	    },
	    hasAddBtnSlot: function hasAddBtnSlot() {
	      return !!this.$slots && !!this.$slots.add;
	    },
	    hasExtensionSlot: function hasExtensionSlot() {
	      return !!this.$slots && !!this.$slots.extension;
	    },
	    wrapperClass: function wrapperClass() {
	      var wrapperClass = [];
	      if (this.tabSize && this.type === 'unborder-card' && !this.isEmpty) {
	        wrapperClass.push("bk-tab-wrapper-".concat(this.tabSize));
	      }
	      return wrapperClass;
	    }
	  },
	  watch: {
	    panelNames: function panelNames(names) {
	      this.checkActiveName();
	    },
	    active: function active(_active) {
	      this.updateActiveBarPosition(_active);
	      if (this.localActive !== _active) {
	        this.localActive = _active;
	        if (this.promise.toggle.rejector) {
	          this.promise.toggle.rejector(false);
	          this.clearToggleStatus();
	        }
	      }
	    },
	    localActive: function localActive(_localActive) {
	      if (_localActive !== this.active) {
	        this.$emit('update:active', _localActive);
	        this.$emit('tab-change', _localActive, this.activePanel);
	        this.updateActivePosition(_localActive);
	      }
	    },
	    showHeader: function showHeader(value) {
	      if (value) {
	        this.resizeHandler();
	      }
	    },
	    tabPosition: function tabPosition() {
	      this.updateActiveBarPosition(this.localActive);
	    },
	    'scrollState.show': function scrollStateShow(isShow) {
	      this.$emit('scroll-show-change', isShow);
	    },
	    size: function size(val) {
	      this.tabSize = val;
	    }
	  },
	  created: function created() {
	    this.resizeHandler = debounce(100, this.calculateScroller);
	  },
	  mounted: function mounted() {
	    this.updateActiveBarPosition(this.localActive);
	    addResizeListener(this.$refs.labelList, this.resizeHandler);
	    addResizeListener(this.$refs.labelWrapper, this.resizeHandler);
	    this.caluclateVerticalPadding();
	  },
	  beforeDestroy: function beforeDestroy() {
	    removeResizeListener(this.$refs.labelList, this.resizeHandler);
	    removeResizeListener(this.$refs.labelWrapper, this.resizeHandler);
	  },
	  methods: {
	    caluclateVerticalPadding: function caluclateVerticalPadding() {
	      var _this2 = this;
	      if (this.type !== 'vertical-card') return;
	      this.$nextTick(function () {
	        var width = _this2.$refs.tabHeader.offsetWidth;
	        _this2.$refs.tabSection.style["padding-".concat(_this2.verticalPosition)] = "".concat(width + 20, "px");
	      });
	    },
	    registerPanel: function registerPanel(panel) {
	      this.panelInstance.push(panel);
	    },
	    deletePanel: function deletePanel(panel) {
	      var index = this.panelInstance.indexOf(panel);
	      if (index !== -1) {
	        this.panelInstance.splice(index, 1);
	      }
	    },
	    togglePanel: function togglePanel(panel) {
	      var _this3 = this;
	      return _asyncToGenerator( _regeneratorRuntime().mark(function _callee2() {
	        var toggleStatus, shouldToggle;
	        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
	          while (1) switch (_context2.prev = _context2.next) {
	            case 0:
	              if (!panel.disabled) {
	                _context2.next = 2;
	                break;
	              }
	              return _context2.abrupt("return", false);
	            case 2:
	              _this3.handleClearHoverTimer();
	              toggleStatus = _this3.promise.toggle;
	              if (!(panel.name === _this3.localActive)) {
	                _context2.next = 7;
	                break;
	              }
	              if (toggleStatus.rejector) {
	                toggleStatus.rejector(false);
	              }
	              return _context2.abrupt("return", false);
	            case 7:
	              if (!(typeof _this3.beforeToggle === 'function')) {
	                _context2.next = 29;
	                break;
	              }
	              if (!toggleStatus.previousPanel) {
	                _context2.next = 14;
	                break;
	              }
	              if (!(toggleStatus.previousPanel === panel)) {
	                _context2.next = 13;
	                break;
	              }
	              return _context2.abrupt("return", false);
	            case 13:
	              toggleStatus.rejector(false);
	            case 14:
	              _context2.prev = 14;
	              _context2.next = 17;
	              return new promise$1( function () {
	                var _ref = _asyncToGenerator( _regeneratorRuntime().mark(function _callee(resolve, reject) {
	                  var confirmed;
	                  return _regeneratorRuntime().wrap(function _callee$(_context) {
	                    while (1) switch (_context.prev = _context.next) {
	                      case 0:
	                        toggleStatus.previousPanel = panel;
	                        toggleStatus.rejector = reject;
	                        _context.next = 4;
	                        return _this3.beforeToggle(panel.name, panel);
	                      case 4:
	                        confirmed = _context.sent;
	                        confirmed ? resolve(confirmed) : reject(confirmed);
	                      case 6:
	                      case "end":
	                        return _context.stop();
	                    }
	                  }, _callee);
	                }));
	                return function (_x, _x2) {
	                  return _ref.apply(this, arguments);
	                };
	              }());
	            case 17:
	              shouldToggle = _context2.sent;
	              if (shouldToggle) {
	                _this3.localActive = panel.name;
	              }
	              _context2.next = 24;
	              break;
	            case 21:
	              _context2.prev = 21;
	              _context2.t0 = _context2["catch"](14);
	              console.warn('Previous tab toggle canceled');
	            case 24:
	              _context2.prev = 24;
	              _this3.clearToggleStatus();
	              return _context2.finish(24);
	            case 27:
	              _context2.next = 30;
	              break;
	            case 29:
	              _this3.localActive = panel.name;
	            case 30:
	            case "end":
	              return _context2.stop();
	          }
	        }, _callee2, null, [[14, 21, 24, 27]]);
	      }))();
	    },
	    clearToggleStatus: function clearToggleStatus() {
	      this.promise.toggle = {
	        previousPanel: null,
	        rejector: null
	      };
	    },
	    checkActiveName: function checkActiveName() {
	      if (this.validateActive && !this.panelNames.includes(this.localActive)) {
	        var newActivePanel = this.panelInstance.length ? this.panelInstance[0] : null;
	        this.localActive = newActivePanel ? newActivePanel.name : '';
	      }
	    },
	    calculateScroller: function calculateScroller() {
	      var _this4 = this;
	      if (!this.showHeader) {
	        return false;
	      }
	      this.$nextTick(function () {
	        var _this4$$refs = _this4.$refs,
	          labelWrapper = _this4$$refs.labelWrapper,
	          labelList = _this4$$refs.labelList,
	          addController = _this4$$refs.addController,
	          extensionController = _this4$$refs.extensionController;
	        var labelWrapperRect = labelWrapper.getBoundingClientRect();
	        var labelListRect = labelList.getBoundingClientRect();
	        var addControllerRect = addController ? addController.getBoundingClientRect() : {
	          width: 0
	        };
	        var extensionControllerReact = extensionController ? extensionController.getBoundingClientRect() : {
	          width: 0
	        };
	        _this4.addCustomRect = _this4.hasAddBtnSlot ? _this4.$refs.addCustom.getBoundingClientRect() : {
	          width: 0
	        };
	        _this4.scrollState.show = labelListRect.width + addControllerRect.width + _this4.addCustomRect.width + extensionControllerReact.width > labelWrapperRect.width;
	        if (!_this4.scrollState.show) {
	          _this4.scrollState.offset = 0;
	          _this4.scrollState.position = 'left';
	        } else {
	          _this4.compensateOffset(labelWrapperRect, labelListRect);
	        }
	        _this4.scrollState.wrapperRect = labelWrapperRect;
	        _this4.scrollState.listRect = labelListRect;
	        _this4.updateActivePosition(_this4.localActive);
	      });
	    },
	    compensateOffset: function compensateOffset(newWrapperRect, newListRect) {
	      var oldWrapperRect = this.scrollState.wrapperRect;
	      if (!oldWrapperRect) {
	        return false;
	      }
	      var overplusWidth = newWrapperRect.width - this.scrollState.offset - newListRect.width;
	      if (overplusWidth > 0) {
	        this.scrollState.offset = newWrapperRect.width - newListRect.width - this.getControllerWidth();
	        this.scrollState.position = 'right';
	      } else {
	        this.scrollState.position = this.scrollState.position === 'left' ? 'left' : 'middle';
	      }
	    },
	    getControllerWidth: function getControllerWidth() {
	      return this.getLeftControllerWidth() + this.getRightControllerWidth();
	    },
	    getLeftControllerWidth: function getLeftControllerWidth() {
	      var prevController = this.$refs.prevController;
	      var controllers = [prevController];
	      var width = 0;
	      controllers.forEach(function (controller) {
	        width += controller ? controller.offsetWidth : 0;
	      });
	      return width;
	    },
	    getRightControllerWidth: function getRightControllerWidth() {
	      var _this$$refs = this.$refs,
	        nextController = _this$$refs.nextController,
	        addController = _this$$refs.addController,
	        extensionController = _this$$refs.extensionController;
	      var controllers = [nextController, addController, extensionController];
	      var width = 0;
	      controllers.forEach(function (controller) {
	        width += controller ? controller.offsetWidth : 0;
	      });
	      if (this.hasAddBtnSlot) {
	        this.addCustomRect = this.hasAddBtnSlot ? this.$refs.addCustom.getBoundingClientRect() : {
	          width: 0
	        };
	        width += this.addCustomRect.width;
	      }
	      return width;
	    },
	    updateActiveBarPosition: function updateActiveBarPosition(active) {
	      var _this5 = this;
	      if (!this.showHeader) {
	        return false;
	      }
	      this.$nextTick(function () {
	        if (isArray$1(_this5.$refs.tabLabel)) {
	          var panel = _this5.$refs.tabLabel.find(function (item) {
	            if (item && item.$el) {
	              var newActive = Object.prototype.toString.call(active) === '[object Number]' ? active + '' : active;
	              return item.$el.dataset.name === newActive;
	            }
	          });
	          if (panel) {
	            var tabLabel = panel.$el;
	            var tabLabelRect = tabLabel.getBoundingClientRect();
	            if (!_this5.isSidePosition) {
	              if (tabLabelRect.width === 0 && tabLabelRect.height === 0) {
	                tabLabel.classList.add('simulate-border-bottom');
	              } else {
	                tabLabel.classList.remove('simulate-border-bottom');
	              }
	              _this5.activeBarStyle.width = _this5.tabSize ? "".concat(tabLabelRect.width - 30, "px") : "".concat(tabLabelRect.width - 40, "px");
	              _this5.activeBarStyle.height = _this5.activeBar.height;
	              _this5.activeBarStyle.transform = _this5.tabSize ? "translateX(".concat(tabLabel.offsetLeft + 15, "px)") : "translateX(".concat(tabLabel.offsetLeft + 20, "px)");
	              _this5.activeBarStyle.left = 0;
	              if (_this5.activeBar.position === 'top') {
	                _this5.activeBarStyle.top = '0px';
	                _this5.activeBarStyle.bottom = 'auto';
	              } else {
	                _this5.activeBarStyle.top = 'auto';
	                _this5.activeBarStyle.bottom = '0px';
	              }
	            } else {
	              _this5.activeBarStyle.left = "".concat(tabLabelRect.width - 2, "px");
	              if (tabLabelRect.width === 0 && tabLabelRect.height === 0) {
	                tabLabel.classList.add('simulate-border-right');
	              } else {
	                tabLabel.classList.remove('simulate-border-right');
	              }
	              _this5.activeBarStyle.width = _this5.activeBar.height;
	              _this5.activeBarStyle.height = "".concat(tabLabelRect.height || 50, "px");
	              _this5.activeBarStyle.transform = "translateY(".concat(tabLabel.offsetTop, "px)");
	              if (_this5.tabPosition === 'right') {
	                _this5.activeBarStyle.left = 0;
	              } else {
	                _this5.activeBarStyle.left = "".concat(tabLabelRect.width - 2, "px");
	              }
	            }
	          }
	        }
	      });
	    },
	    updateActivePosition: function updateActivePosition(active) {
	      var _this6 = this;
	      this.updateActiveBarPosition(active);
	      if (!this.scrollState.show || !this.showHeader) {
	        return false;
	      }
	      this.$nextTick(function () {
	        var index = _this6.panelNames.indexOf(active);
	        if (index !== -1) {
	          var _this6$scrollState = _this6.scrollState,
	            wrapperRect = _this6$scrollState.wrapperRect,
	            listRect = _this6$scrollState.listRect;
	          var tabLabel = _this6.$refs.tabLabel[index].$el;
	          var tabLabelRect = tabLabel.getBoundingClientRect();
	          var labelWrapperWidth = wrapperRect.width - _this6.getControllerWidth();
	          var leftThreshold = tabLabel.offsetLeft;
	          var rightThreshold = Math.abs(tabLabel.offsetLeft - labelWrapperWidth + tabLabelRect.width);
	          var isLeftOutside = tabLabelRect.left < wrapperRect.left + _this6.getLeftControllerWidth();
	          var isRightOutside = tabLabelRect.right > wrapperRect.right - _this6.getRightControllerWidth();
	          if (isLeftOutside) {
	            _this6.scrollState.offset = -1 * leftThreshold;
	            _this6.scrollState.position = leftThreshold ? 'middle' : 'left';
	          } else if (isRightOutside) {
	            _this6.scrollState.offset = -1 * rightThreshold;
	            _this6.scrollState.position = listRect.width - rightThreshold === labelWrapperWidth ? 'right' : 'middle';
	          }
	        }
	      });
	    },
	    stepToPrev: function stepToPrev() {
	      var _this$scrollState = this.scrollState,
	        position = _this$scrollState.position,
	        basicStep = _this$scrollState.basicStep,
	        offset = _this$scrollState.offset;
	      if (position === 'left') {
	        return false;
	      }
	      var newOffset = offset + basicStep;
	      if (newOffset > 0) {
	        newOffset = 0;
	        this.scrollState.position = 'left';
	      } else {
	        this.scrollState.position = 'middle';
	      }
	      this.scrollState.offset = newOffset;
	    },
	    stepToNext: function stepToNext() {
	      var _this$scrollState2 = this.scrollState,
	        position = _this$scrollState2.position,
	        basicStep = _this$scrollState2.basicStep,
	        wrapperRect = _this$scrollState2.wrapperRect,
	        listRect = _this$scrollState2.listRect,
	        offset = _this$scrollState2.offset;
	      if (position === 'right') {
	        return false;
	      }
	      var controllerWidth = this.getControllerWidth();
	      var newOffset = offset - basicStep;
	      if (wrapperRect.width - controllerWidth - newOffset > listRect.width) {
	        newOffset = wrapperRect.width - listRect.width - controllerWidth;
	        this.scrollState.position = 'right';
	      } else {
	        this.scrollState.position = 'middle';
	      }
	      this.scrollState.offset = newOffset;
	    },
	    handleAddPanel: function handleAddPanel() {
	      this.$emit('add-panel');
	    },
	    handleClosePanel: function handleClosePanel(index, panel) {
	      this.$emit('close-panel', index, panel);
	    },
	    handleLabelHover: function handleLabelHover(panel) {
	      var _this7 = this;
	      if (!this.changeOnHover || panel.disabled || panel.name === this.localActive) {
	        return false;
	      }
	      this.handleClearHoverTimer();
	      this.hoverTimer = setTimeout(function () {
	        _this7.togglePanel(panel);
	      }, this.changeOnHoverDelay);
	    },
	    handleClearHoverTimer: function handleClearHoverTimer() {
	      this.hoverTimer && clearTimeout(this.hoverTimer);
	      this.hoverTimer = null;
	    },
	    dragStart: function dragStart(index, $event) {
	      this.dragStartIndex = index;
	      this.draggingEle = this.guid;
	      $event.dataTransfer.effectAllowed = 'move';
	      this.$emit('on-drag-tab', index, $event);
	    },
	    dragenter: function dragenter(index) {
	      if (this.distinctRoots(this.draggingEle, this.guid)) {
	        this.dragenterIndex = index;
	      }
	    },
	    dragend: function dragend() {
	      this.dragenterIndex = -1;
	      this.dragStartIndex = -1;
	      this.draggingEle = null;
	    },
	    drop: function drop(index, $event) {
	      var _this8 = this;
	      if (!this.visiblePanels[index].sortable) {
	        return false;
	      }
	      if (!this.distinctRoots(this.draggingEle, this.guid)) {
	        return false;
	      }
	      if (this.sortType === 'insert') {
	        if (this.dragStartIndex < index) {
	          this.visiblePanels.splice(index + 1, 0, this.visiblePanels[this.dragStartIndex]);
	          this.visiblePanels.splice(this.dragStartIndex, 1);
	        } else if (this.dragStartIndex > index) {
	          this.visiblePanels.splice(index, 0, this.visiblePanels[this.dragStartIndex]);
	          this.visiblePanels.splice(this.dragStartIndex + 1, 1);
	        } else {
	          return false;
	        }
	      } else {
	        this.swapArr(this.visiblePanels, this.dragStartIndex, index);
	      }
	      this.$emit('sort-change', this.dragStartIndex, index);
	      var timer = setTimeout(function () {
	        _this8.updateActiveBarPosition(_this8.localActive);
	        clearTimeout(timer);
	        timer = null;
	      }, 200);
	    },
	    swapArr: function swapArr(arr, a, b) {
	      var swap = arr[a];
	      arr[a] = arr[b];
	      arr[b] = swap;
	    },
	    distinctRoots: function distinctRoots(el1, el2) {
	      return el1 === el2;
	    }
	  }
	};

	function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
	, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
	  if (typeof shadowMode !== 'boolean') {
	    createInjectorSSR = createInjector;
	    createInjector = shadowMode;
	    shadowMode = false;
	  }
	  var options = typeof script === 'function' ? script.options : script;
	  if (template && template.render) {
	    options.render = template.render;
	    options.staticRenderFns = template.staticRenderFns;
	    options._compiled = true;
	    if (isFunctionalTemplate) {
	      options.functional = true;
	    }
	  }
	  if (scopeId) {
	    options._scopeId = scopeId;
	  }
	  var hook;
	  if (moduleIdentifier) {
	    hook = function hook(context) {
	      context = context ||
	      this.$vnode && this.$vnode.ssrContext ||
	      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
	      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
	        context = __VUE_SSR_CONTEXT__;
	      }
	      if (style) {
	        style.call(this, createInjectorSSR(context));
	      }
	      if (context && context._registeredComponents) {
	        context._registeredComponents.add(moduleIdentifier);
	      }
	    };
	    options._ssrRegister = hook;
	  } else if (style) {
	    hook = shadowMode ? function () {
	      style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
	    } : function (context) {
	      style.call(this, createInjector(context));
	    };
	  }
	  if (hook) {
	    if (options.functional) {
	      var originalRender = options.render;
	      options.render = function renderWithStyleInjection(h, context) {
	        hook.call(context);
	        return originalRender(h, context);
	      };
	    } else {
	      var existing = options.beforeCreate;
	      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	    }
	  }
	  return script;
	}
	var normalizeComponent_1 = normalizeComponent;

	/* script */
	var __vue_script__ = script;
	/* template */
	var __vue_render__ = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c('div', {
	    class: _vm.tabClass,
	    style: _vm.tabStyle
	  }, [_c('div', {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.showHeader,
	      expression: "showHeader"
	    }],
	    ref: "tabHeader",
	    staticClass: "bk-tab-header",
	    style: _vm.headerStyle
	  }, [_c('div', {
	    staticClass: "bk-tab-header-setting",
	    class: {
	      'has-setting': _vm.$slots.setting
	    },
	    style: {
	      height: _vm.labelHeight + "px",
	      lineHeight: _vm.labelHeight + "px"
	    }
	  }, [_vm._t("setting")], 2), _c('div', {
	    ref: "labelWrapper",
	    staticClass: "bk-tab-label-wrapper",
	    class: {
	      'has-scroller': _vm.scrollState.show && !_vm.isSidePosition,
	      'has-add': (_vm.addable || _vm.hasAddBtnSlot) && !_vm.isSidePosition,
	      'has-extension': _vm.hasExtensionSlot
	    },
	    style: {
	      padding: _vm.scrollState.show && !_vm.isSidePosition ? "0 " + (_vm.addCustomRect.width + 24) + "px 0 24px" : undefined
	    }
	  }, [_c('ul', {
	    ref: "labelList",
	    class: ['bk-tab-label-list', {
	      'bk-tab-label-list-has-bar': _vm.hasActiveBar
	    }],
	    style: _vm.tabLabelListStyle
	  }, _vm._l(_vm.visiblePanels, function (panel, index) {
	    return _c("bk-tab-label", {
	      key: panel.name + index,
	      ref: "tabLabel",
	      refInFor: true,
	      tag: "li",
	      staticClass: "bk-tab-label-item",
	      class: {
	        active: panel.name === _vm.localActive,
	        'is-first': index === 0,
	        'is-last': index === _vm.visiblePanels.length - 1,
	        'is-disabled': panel.disabled,
	        'is-dragging': _vm.dragStartIndex === index,
	        'is-dragenter': _vm.dragenterIndex === index && index !== _vm.dragStartIndex && panel.sortable,
	        'is-unsortable': _vm.dragenterIndex === index && !panel.sortable
	      },
	      style: {
	        lineHeight: _vm.labelHeight + "px"
	      },
	      attrs: {
	        "data-name": panel.name,
	        "draggable": _vm.sortable && panel.sortable,
	        "panel": panel,
	        "index": index,
	        "closable": _vm.closable,
	        "is-side-position": _vm.isSidePosition
	      },
	      nativeOn: {
	        "dragstart": function dragstart($event) {
	          _vm.dragStart(index, $event);
	        },
	        "dragenter": function dragenter($event) {
	          $event.preventDefault();
	          _vm.dragenter(index, $event);
	        },
	        "dragleave": function dragleave($event) {
	          $event.preventDefault();
	        },
	        "dragover": function dragover($event) {
	          $event.preventDefault();
	        },
	        "dragend": function dragend($event) {
	          $event.preventDefault();
	          _vm.dragend(index, $event);
	        },
	        "drop": function drop($event) {
	          $event.preventDefault();
	          _vm.drop(index, $event);
	        },
	        "&mouseenter": function mouseenter($event) {
	          _vm.handleLabelHover(panel);
	        },
	        "&mouseleave": function mouseleave($event) {
	          _vm.handleClearHoverTimer(panel);
	        }
	      }
	    });
	  }), 1), _vm.hasExtensionSlot ? _c('div', {
	    ref: "extensionController",
	    class: {
	      'bk-tab-extension-controller': true,
	      'has-setting': _vm.$slots.extension
	    },
	    style: {
	      height: _vm.labelHeight + "px",
	      lineHeight: _vm.labelHeight + "px"
	    }
	  }, [_vm._t("extension")], 2) : _vm._e(), _vm.addable && !_vm.isSidePosition && !_vm.hasAddBtnSlot ? _c('i', {
	    ref: "addController",
	    staticClass: "bk-tab-add-controller bk-icon icon-plus",
	    class: {
	      'left-border': !_vm.visiblePanels.length && !_vm.hasExtensionSlot,
	      'next-right': _vm.addShowNextRight
	    },
	    style: {
	      height: _vm.labelHeight + "px",
	      lineHeight: _vm.labelHeight + "px"
	    },
	    on: {
	      "click": _vm.handleAddPanel
	    }
	  }) : _vm._e(), _vm.hasAddBtnSlot ? _c('div', {
	    ref: "addCustom",
	    staticClass: "bk-tab-add-custom",
	    class: {
	      'next-right': _vm.addShowNextRight
	    },
	    style: {
	      height: (_vm.scrollState.show && !_vm.isSidePosition ? _vm.labelHeight - 1 : _vm.labelHeight - 2) + "px",
	      lineHeight: _vm.labelHeight + "px"
	    }
	  }, [_vm._t("add")], 2) : _vm._e(), _vm.scrollState.show ? [_c('i', {
	    ref: "prevController",
	    staticClass: "bk-tab-scroll-controller prev bk-icon icon-angle-left",
	    class: {
	      'disabled': _vm.scrollState.position === 'left'
	    },
	    style: {
	      height: _vm.labelHeight - 1 + "px",
	      lineHeight: _vm.labelHeight + "px"
	    },
	    on: {
	      "click": _vm.stepToPrev
	    }
	  }), _c('i', {
	    ref: "nextController",
	    staticClass: "bk-tab-scroll-controller next bk-icon icon-angle-right",
	    class: {
	      'disabled': _vm.scrollState.position === 'right'
	    },
	    style: {
	      height: _vm.labelHeight - 1 + "px",
	      lineHeight: _vm.labelHeight + "px",
	      right: _vm.hasAddBtnSlot || _vm.addable ? (_vm.addShowNextRight ? 0 : _vm.addCustomRect.width || 40) + "px" : undefined
	    },
	    on: {
	      "click": _vm.stepToNext
	    }
	  })] : _vm._e()], 2)]), _c('div', {
	    ref: "tabSection",
	    staticClass: "bk-tab-section"
	  }, [_vm._t("default")], 2)]);
	};
	var __vue_staticRenderFns__ = [];

	/* style */
	var __vue_inject_styles__ = undefined;
	/* scoped */
	var __vue_scope_id__ = undefined;
	/* module identifier */
	var __vue_module_identifier__ = undefined;
	/* functional template */
	var __vue_is_functional_template__ = false;
	/* style inject */

	/* style inject SSR */

	/* style inject shadow dom */

	var __vue_component__ = /*#__PURE__*/normalizeComponent_1({
	  render: __vue_render__,
	  staticRenderFns: __vue_staticRenderFns__
	}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

	var _objectSap = function (KEY, exec) {
	  var fn = (_core.Object || {})[KEY] || Object[KEY];
	  var exp = {};
	  exp[KEY] = exec(fn);
	  _export(_export.S + _export.F * _fails(function () { fn(1); }), 'Object', exp);
	};

	_objectSap('keys', function () {
	  return function keys(it) {
	    return _objectKeys(_toObject(it));
	  };
	});

	var keys = _core.Object.keys;

	var keys$1 = keys;

	function setInstaller (component, afterInstall) {
	  component.install = function (Vue) {
	    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	    var props = component.props || {};
	    keys$1(options).forEach(function (key) {
	      if (props.hasOwnProperty(key)) {
	        if (typeof props[key] === 'function' || props[key] instanceof Array) {
	          props[key] = {
	            type: props[key],
	            default: options[key]
	          };
	        } else {
	          props[key].default = options[key];
	        }
	      }
	    });
	    component.name = options.namespace ? component.name.replace('bk', options.namespace) : component.name;
	    Vue.component(component.name, component);
	    typeof afterInstall === 'function' && afterInstall(Vue, options);
	  };
	}

	setInstaller(__vue_component__);

	exports.default = __vue_component__;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
